Index: /LMDZ5/trunk/libf/dyn3dmem/integrd_loc.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dmem/integrd_loc.F	(revision 1672)
+++ /LMDZ5/trunk/libf/dyn3dmem/integrd_loc.F	(revision 1673)
@@ -4,5 +4,5 @@
       SUBROUTINE integrd_loc
      $  (  nq,vcovm1,ucovm1,tetam1,psm1,massem1,
-     $     dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps0,masse,phis,finvmaold)
+     $     dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps0,masse,phis) !,finvmaold)
       USE parallel
       USE control_mod
@@ -37,4 +37,5 @@
 #include "temps.h"
 #include "serre.h"
+#include "iniprint.h"
       include 'mpif.h'
 
@@ -42,18 +43,26 @@
 c   ----------
 
-      INTEGER nq
-
-      REAL vcov(ijb_v:ije_v,llm),ucov(ijb_u:ije_u,llm)
-      REAL teta(ijb_u:ije_u,llm)
-      REAL q(ijb_u:ije_u,llm,nq)
-      REAL ps0(ijb_u:ije_u),masse(ijb_u:ije_u,llm),phis(ijb_u:ije_u)
-
-      REAL vcovm1(ijb_v:ije_v,llm),ucovm1(ijb_u:ije_u,llm)
-      REAL tetam1(ijb_u:ije_u,llm),psm1(ijb_u:ije_u)
-      REAL massem1(ijb_u:ije_u,llm)
-
-      REAL dv(ijb_v:ije_v,llm),du(ijb_u:ije_u,llm)
-      REAL dteta(ijb_u:ije_u,llm),dp(ijb_u:ije_u)
-      REAL dq(ijb_u:ije_u,llm,nq), finvmaold(ijb_u:ije_u,llm)
+      INTEGER,intent(in) :: nq ! number of tracers to handle in this routine
+
+      REAL,INTENT(INOUT) :: vcov(ijb_v:ije_v,llm) ! covariant meridional wind
+      REAL,INTENT(INOUT) :: ucov(ijb_u:ije_u,llm) ! covariant zonal wind
+      REAL,INTENT(INOUT) :: teta(ijb_u:ije_u,llm) ! potential temperature
+      REAL,INTENT(INOUT) :: q(ijb_u:ije_u,llm,nq) ! advected tracers
+      REAL,INTENT(INOUT) :: ps0(ijb_u:ije_u) ! surface pressure
+      REAL,INTENT(INOUT) :: masse(ijb_u:ije_u,llm) ! atmospheric mass
+      REAL,INTENT(INOUT) :: phis(ijb_u:ije_u) ! ground geopotential !!! unused
+      ! values at previous time step
+      REAL,INTENT(INOUT) :: vcovm1(ijb_v:ije_v,llm)
+      REAL,INTENT(INOUT) :: ucovm1(ijb_u:ije_u,llm)
+      REAL,INTENT(INOUT) :: tetam1(ijb_u:ije_u,llm)
+      REAL,INTENT(INOUT) :: psm1(ijb_u:ije_u)
+      REAL,INTENT(INOUT) :: massem1(ijb_u:ije_u,llm)
+      ! the tendencies to add
+      REAL,INTENT(INOUT) :: dv(ijb_v:ije_v,llm)
+      REAL,INTENT(INOUT) :: du(ijb_u:ije_u,llm)
+      REAL,INTENT(INOUT) :: dteta(ijb_u:ije_u,llm)
+      REAL,INTENT(INOUT) :: dp(ijb_u:ije_u)
+      REAL,INTENT(INOUT) :: dq(ijb_u:ije_u,llm,nq) !!! unused
+!      REAL,INTENT(INOUT) ::finvmaold(ijb_u:ije_u,llm) !!! unused
 
 c   Local:
@@ -62,9 +71,10 @@
       REAL vscr( ijb_v:ije_v ),uscr( ijb_u:ije_u )
       REAL hscr( ijb_u:ije_u ),pscr(ijb_u:ije_u)
-      REAL massescr( ijb_u:ije_u,llm ), finvmasse(ijb_u:ije_u,llm)
+      REAL massescr( ijb_u:ije_u,llm )
+!      REAL finvmasse(ijb_u:ije_u,llm)
       REAL tpn,tps,tppn(iim),tpps(iim)
       REAL qpn,qps,qppn(iim),qpps(iim)
 
-      INTEGER  l,ij,iq
+      INTEGER  l,ij,iq,i,j
 
       REAL SSUM
@@ -74,5 +84,5 @@
       LOGICAL,SAVE :: checksum_all=.TRUE.
       INTEGER :: stop_it
-      INTEGER :: ierr,j
+      INTEGER :: ierr
 
 c-----------------------------------------------------------------------
@@ -137,8 +147,14 @@
 !     &                   MPI_LOGICAL,MPI_LOR,COMM_LMDZ,ierr)
       IF( .NOT. checksum ) THEN
-         PRINT*,' Au point ij = ',stop_it, ' , pression sol neg. '
-     &         , ps(stop_it)
-         STOP' dans integrd'
-      ENDIF
+          write(lunout,*) "integrd: negative surface pressure ",
+     &                                                ps(stop_it)
+         write(lunout,*) " at node ij =", stop_it
+         ! since ij=j+(i-1)*jjp1 , we have
+!         j=modulo(stop_it,jjp1)
+!         i=1+(stop_it-j)/jjp1
+!         write(lunout,*) " lon = ",rlonv(i)*180./pi, " deg",
+!     &                   " lat = ",rlatu(j)*180./pi, " deg"
+      ENDIF
+
 c$OMP END MASTER
 c$OMP BARRIER
@@ -160,5 +176,5 @@
         call WriteField_u('int_dteta',dteta)
         call WriteField_u('int_dp',dp)
-        call WriteField_u('int_finvmaold',finvmaold)
+!        call WriteField_u('int_finvmaold',finvmaold)
         do j=1,nq
           call WriteField_u('int_q'//trim(int2str(j)),
@@ -206,18 +222,20 @@
       CALL massdair_loc (     p  , masse         )
 
-c      CALL   SCOPY( ijp1llm  , masse, 1, finvmasse,  1      )
-      ijb=ij_begin
-      ije=ij_end
-      
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
-      DO  l = 1,llm
-        finvmasse(ijb:ije,l)=masse(ijb:ije,l)
-      ENDDO
-c$OMP END DO NOWAIT
-
-      jjb=jj_begin
-      jje=jj_end
-      CALL filtreg_p( finvmasse,jjb_u,jje_u,jjb,jje, jjp1, llm,
-     &                -2, 2, .TRUE., 1  )
+! Ehouarn : we don't use/need finvmaold and finvmasse,
+!           so might as well not compute them
+!c      CALL   SCOPY( ijp1llm  , masse, 1, finvmasse,  1      )
+!      ijb=ij_begin
+!      ije=ij_end
+!      
+!c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
+!      DO  l = 1,llm
+!        finvmasse(ijb:ije,l)=masse(ijb:ije,l)
+!      ENDDO
+!c$OMP END DO NOWAIT
+
+!      jjb=jj_begin
+!      jje=jj_end
+!      CALL filtreg_p( finvmasse,jjb_u,jje_u,jjb,jje, jjp1, llm,
+!     &                -2, 2, .TRUE., 1  )
 c
 
@@ -320,5 +338,4 @@
 
           CALL qminimum_loc( q, nq, deltap )
-	 endif ! of if (planet_type.eq."earth")
 c
 c    .....  Calcul de la valeur moyenne, unique  aux poles pour  q .....
@@ -371,11 +388,15 @@
       ENDIF
       
-c         CALL  SCOPY( ijp1llm , finvmasse, 1, finvmaold, 1 )
-
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-      DO l = 1, llm      
-        finvmaold(ijb:ije,l)=finvmasse(ijb:ije,l)        
-      ENDDO
-c$OMP END DO NOWAIT
+! Ehouarn: forget about finvmaold
+!c         CALL  SCOPY( ijp1llm , finvmasse, 1, finvmaold, 1 )
+
+!c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+!      DO l = 1, llm      
+!        finvmaold(ijb:ije,l)=finvmasse(ijb:ije,l)        
+!      ENDDO
+!c$OMP END DO NOWAIT
+
+      endif ! of if (planet_type.eq."earth")
+
 c
 c
Index: /LMDZ5/trunk/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3dmem/leapfrog_loc.F	(revision 1672)
+++ /LMDZ5/trunk/libf/dyn3dmem/leapfrog_loc.F	(revision 1673)
@@ -1,4 +1,4 @@
 ! 
-! $Id: leapfrog_p.F 1299 2010-01-20 14:27:21Z fairhead $
+! $Id$
 !
 c
@@ -119,8 +119,8 @@
 
 c   tendances physiques
-!      REAL,SAVE,ALLOCATABLE :: dvfi(:,:),dufi(:,:)
-!      REAL,SAVE,ALLOCATABLE :: dtetafi(:,:)
-!      REAL,SAVE,ALLOCATABLE :: dpfi(:)
-!      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: dqfi
+      REAL,SAVE,ALLOCATABLE :: dvfi(:,:),dufi(:,:)
+      REAL,SAVE,ALLOCATABLE :: dtetafi(:,:)
+      REAL,SAVE,ALLOCATABLE :: dpfi(:)
+      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: dqfi
 
 c   variables pour le fichier histoire
@@ -150,4 +150,5 @@
       REAL :: secondes
 
+      logical :: physic
       LOGICAL first,callinigrads
 
@@ -174,5 +175,5 @@
 
       character*80 dynhist_file, dynhistave_file
-      character*20 modname
+      character(len=*),parameter :: modname="leapfrog_loc"
       character*80 abort_message
 
@@ -195,5 +196,4 @@
 
       INTEGER :: true_itau
-      LOGICAL :: verbose=.true.
       INTEGER :: iapptrac
       INTEGER :: AdjustCount
@@ -215,7 +215,8 @@
       itaufin   = nday*day_step
       itaufinp1 = itaufin +1
-      modname="leapfrog_p"
 
       itau = 0
+      physic=.true.
+      if (iflag_phys==0.or.iflag_phys==2) physic=.false.
       CALL init_nan
       CALL leapfrog_allocate
@@ -252,9 +253,9 @@
 !      ALLOCATE(dvdis(ijb_v:ije_v,llm),dudis(ijb_u:ije_u,llm))
 !      ALLOCATE(dtetadis(ijb_u:ije_u,llm))
-!      ALLOCATE(dvfi(ijb_v:ije_v,llm),dufi(ijb_u:ije_u,llm))
-!      ALLOCATE(dtetafi(ijb_u:ije_u,llm))
-!      ALLOCATE(dpfi(ijb_u:ije_u))
+      ALLOCATE(dvfi(ijb_v:ije_v,llm),dufi(ijb_u:ije_u,llm))
+      ALLOCATE(dtetafi(ijb_u:ije_u,llm))
+      ALLOCATE(dpfi(ijb_u:ije_u))
 !      ALLOCATE(dq(ijb_u:ije_u,llm,nqtot))
-!      ALLOCATE(dqfi(ijb_u:ije_u,llm,nqtot))
+      ALLOCATE(dqfi(ijb_u:ije_u,llm,nqtot))
 !      ALLOCATE(dqfi_tmp(iip1,llm,nqtot))
 !      ALLOCATE(finvmaold(ijb_u:ije_u,llm))
@@ -277,9 +278,12 @@
 
 c$OMP MASTER
-      dq=0.
+      dq(:,:,:)=0.
       CALL pression ( ijnb_u, ap, bp, ps, p       )
 c$OMP END MASTER
+      if (pressure_exner) then
       CALL exner_hyb_loc( ijnb_u, ps, p,alpha,beta, pks, pk, pkf)
-
+      else 
+        CALL exner_milieu_loc( ijnb_u, ps, p, beta, pks, pk, pkf )
+      endif
 c-----------------------------------------------------------------------
 c   Debut de l'integration temporelle:
@@ -287,9 +291,15 @@
 c et du parallelisme !!
 
-   1  CONTINUE
-
-      jD_cur = jD_ref + day_ini - day_ref + int (itau * dtvr / daysec) 
-      jH_cur = jH_ref +                                                 &
-     &          (itau * dtvr / daysec - int(itau * dtvr / daysec)) 
+   1  CONTINUE ! Matsuno Forward step begins here
+
+      jD_cur = jD_ref + day_ini - day_ref +                             &
+     &          itau/day_step
+      jH_cur = jH_ref + start_time +                                    &
+     &         mod(itau,day_step)/float(day_step) 
+      if (jH_cur > 1.0 ) then
+        jD_cur = jD_cur +1.
+        jH_cur = jH_cur -1.
+      endif
+
 
 #ifdef CPP_IOIPSL
@@ -323,9 +333,10 @@
          psm1= ps
          
-         finvmaold = masse
-c$OMP END MASTER
-c$OMP BARRIER
-         CALL filtreg_p ( finvmaold ,jjb_u,jje_u,jjb_u,jje_u,jjp1, llm,
-     &                    -2,2, .TRUE., 1 )
+! Ehouarn: finvmaold is actually not used       
+!         finvmaold = masse
+c$OMP END MASTER
+c$OMP BARRIER
+!         CALL filtreg_p ( finvmaold ,jjb_u,jje_u,jjb_u,jje_u,jjp1, llm,
+!     &                    -2,2, .TRUE., 1 )
        else
 ! Save fields obtained at previous time step as '...m1'
@@ -343,5 +354,5 @@
            tetam1   (ijb:ije,l) = teta  (ijb:ije,l)
            massem1  (ijb:ije,l) = masse (ijb:ije,l)
-           finvmaold(ijb:ije,l)=masse(ijb:ije,l)
+!           finvmaold(ijb:ije,l)=masse(ijb:ije,l)
                  
            if (pole_sud) ije=ij_end-iip1
@@ -353,6 +364,7 @@
 
 
-          CALL filtreg_p(finvmaold ,jjb_u,jje_u,jj_begin,jj_end,jjp1, 
-     .                    llm, -2,2, .TRUE., 1 )
+! Ehouarn: finvmaold not used
+!          CALL filtreg_p(finvmaold ,jjb_u,jje_u,jj_begin,jj_end,jjp1, 
+!     .                    llm, -2,2, .TRUE., 1 )
 
        endif ! of if (FirstCaldyn)
@@ -370,5 +382,5 @@
 cym      call minmax(ijp1llm,q(:,:,3),zqmin,zqmax)
 
-   2  CONTINUE
+   2  CONTINUE ! Matsuno backward or leapfrog step begins here
 
 c$OMP MASTER
@@ -399,12 +411,14 @@
       ! Purely Matsuno time stepping
          IF( MOD(itau,iconser) .EQ.0.AND.  forward    ) conser = .TRUE.
-         IF( MOD(itau,idissip ).EQ.0.AND..NOT.forward ) apdiss = .TRUE.
+         IF( MOD(itau,dissip_period ).EQ.0.AND..NOT.forward ) 
+     s        apdiss = .TRUE.
          IF( MOD(itau,iphysiq ).EQ.0.AND..NOT.forward 
-     s          .and. iflag_phys.EQ.1                 ) apphys = .TRUE.
+     s          .and. physic                        ) apphys = .TRUE.
       ELSE
       ! Leapfrog/Matsuno time stepping 
          IF( MOD(itau   ,iconser) .EQ. 0              ) conser = .TRUE.
-         IF( MOD(itau+1,idissip)  .EQ. 0              ) apdiss = .TRUE.
-         IF( MOD(itau+1,iphysiq).EQ.0.AND.iflag_phys.EQ.1) apphys=.TRUE.
+         IF( MOD(itau+1,dissip_period).EQ.0 .AND. .NOT. forward )
+     s        apdiss = .TRUE.
+         IF( MOD(itau+1,iphysiq).EQ.0.AND.physic) apphys=.TRUE.
       END IF
 
@@ -450,6 +464,6 @@
 c$OMP MASTER 
            call allgather_timer_average
-        verbose=.TRUE.
-        if (Verbose) then
+
+        if (prt_level > 9) then
         
         print *,'*********************************'
@@ -622,4 +636,5 @@
       call start_timer(timer_caldyn)
 
+      ! compute geopotential phi()
       CALL geopot_loc  ( ip1jmp1, teta  , pk , pks,  phis  , phi   )
 
@@ -697,6 +712,6 @@
 
        CALL integrd_loc ( 2,vcovm1,ucovm1,tetam1,psm1,massem1 ,
-     $         dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis ,
-     $              finvmaold                                    )
+     $         dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis)
+!     $              finvmaold                                    )
 
 !       CALL FTRACE_REGION_END("integrd")
@@ -1081,8 +1096,19 @@
 !$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
        do l=1,llm
-       teta(ijb:ije,l)=teta(ijb:ije,l)
-     &  -iphysiq*dtvr*(teta(ijb:ije,l)-tetarappel(ijb:ije,l))/taurappel
+       teta(ijb:ije,l)=teta(ijb:ije,l) -dtvr*
+     &        (teta(ijb:ije,l)-tetarappel(ijb:ije,l))*
+     &                 (knewt_g+knewt_t(l)*clat4(ijb:ije))        
        enddo
 !$OMP END DO
+
+!$OMP MASTER
+       if (planet_type.eq."giant") then
+         ! add an intrinsic heat flux at the base of the atmosphere
+         teta(ijb:ije,1) = teta(ijb:ije,1)
+     &        + dtvr * aire(ijb:ije) * ihf / cpp / masse(ijb:ije,1)
+       endif
+!$OMP END MASTER
+!$OMP BARRIER
+
 
        call Register_Hallo_u(ucov,llm,0,1,1,0,Request_Physic)
@@ -1092,6 +1118,37 @@
        call WaitRequest(Request_Physic)     
 c$OMP BARRIER
-       call friction_loc(ucov,vcov,iphysiq*dtvr)
+       call friction_loc(ucov,vcov,dtvr)
 !$OMP BARRIER
+
+        ! Sponge layer (if any)
+        IF (ok_strato) THEN
+          ! set dufi,dvfi,... to zero
+          ijb=ij_begin
+          ije=ij_end
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+          do l=1,llm
+            dufi(ijb:ije,l)=0
+            dtetafi(ijb:ije,l)=0
+            dqfi(ijb:ije,l,1:nqtot)=0
+          enddo
+!$OMP END DO
+!$OMP MASTER
+          dpfi(ijb:ije)=0
+!$OMP END MASTER
+          ijb=ij_begin
+          ije=ij_end
+          if (pole_sud) ije=ije-iip1
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+          do l=1,llm
+            dvfi(ijb:ije,l)=0
+          enddo
+!$OMP END DO
+
+          CALL top_bound_loc(vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
+          CALL addfi_loc( dtvr, leapf, forward   ,
+     $                  ucov, vcov, teta , q   ,ps ,
+     $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
+!$OMP BARRIER
+        ENDIF ! of IF (ok_strato) 
       ENDIF ! of IF(iflag_phys.EQ.2)
 
@@ -1099,5 +1156,9 @@
         CALL pression_loc ( ip1jmp1, ap, bp, ps, p                  )
 c$OMP BARRIER
-        CALL exner_hyb_loc( ip1jmp1, ps, p,alpha,beta, pks, pk, pkf )
+        if (pressure_exner) then
+        CALL exner_hyb_loc( ijnb_u, ps, p,alpha,beta, pks, pk, pkf )
+        else 
+          CALL exner_milieu_loc( ijnb_u, ps, p, beta, pks, pk, pkf )
+        endif
 c$OMP BARRIER
 
@@ -1496,9 +1557,9 @@
 c$OMP BARRIER
 
-              if (planet_type.eq."earth") then
+!              if (planet_type.eq."earth") then
 ! Write an Earth-format restart file
                 CALL dynredem1_loc("restart.nc",0.0,
      &                           vcov,ucov,teta,q,masse,ps)
-              endif ! of if (planet_type.eq."earth")
+!              endif ! of if (planet_type.eq."earth")
 
 !              CLOSE(99)
@@ -1608,8 +1669,8 @@
 
               IF(itau.EQ.itaufin) THEN
-                if (planet_type.eq."earth") then
+!                if (planet_type.eq."earth") then
                    CALL dynredem1_loc("restart.nc",0.0,
      .                               vcov,ucov,teta,q,masse,ps)
-                endif ! of if (planet_type.eq."earth")
+!               endif ! of if (planet_type.eq."earth")
               ENDIF ! of IF(itau.EQ.itaufin)
 
